"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
// services
var grid_engine_service_1 = require("./grid-engine.service");
var GridStatusProps = /** @class */ (function () {
    function GridStatusProps() {
    }
    return GridStatusProps;
}());
exports.GridStatusProps = GridStatusProps;
var IGridStatusDetail = /** @class */ (function () {
    function IGridStatusDetail() {
    }
    return IGridStatusDetail;
}());
exports.IGridStatusDetail = IGridStatusDetail;
var GridStatusState = /** @class */ (function () {
    function GridStatusState() {
    }
    return GridStatusState;
}());
exports.GridStatusState = GridStatusState;
var GridStatus = /** @class */ (function (_super) {
    __extends(GridStatus, _super);
    function GridStatus(props) {
        var _this = _super.call(this, props) || this;
        _this.timer = null;
        _this.state = { gridStats: [], total: 0 };
        // set the updateStatus to be called every n milliseconds
        _this.timer = setInterval(function () {
            _this.updateStatus();
        }, props.updateInterval);
        _this.gridEngineService = new grid_engine_service_1.GridEngineService(props.baseUrl);
        return _this;
    }
    GridStatus.prototype.updateStatus = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, gridStats, total;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.gridEngineService.getStatus()];
                    case 1:
                        _a = _b.sent(), gridStats = _a.gridStats, total = _a.total;
                        // pass new values from getStatus with current getStatus function pointer for state change
                        this.setState({
                            gridStats: gridStats || [],
                            total: total || 0
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    GridStatus.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", null, React.createElement("button", {
            id: "btnRefresh",
            onClick: function () { return _this.updateStatus(); }
        }, "Refresh ", React.createElement("i", { className: "fa fa-refresh" })), React.createElement("h3", null, React.createElement("i", null, "Total Running Jobs: ", this.state.total)), React.createElement("table", { id: "tblGridStatus", className: "table fixed table-condensed table-nonfluid text-align-center" }, React.createElement("thead", null, React.createElement("tr", null, React.createElement("th", null, "Name"), React.createElement("th", null, "Queued"), React.createElement("th", null, "Running"), React.createElement("th", null, "Halted"))), React.createElement("tbody", null, this.state.gridStats.map(function (s) {
            return (React.createElement("tr", null, React.createElement("td", null, s.name), React.createElement("td", null, s.queued), React.createElement("td", null, s.running), React.createElement("td", null, s.halted)));
        })))));
    };
    return GridStatus;
}(React.Component));
exports.GridStatus = GridStatus;
//# sourceMappingURL=grid-status-component.js.map