"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var widgets_1 = require("@phosphor/widgets");
var React = require("react");
var ReactDOM = require("react-dom");
// components
var grid_status_component_1 = require("./grid-status-component");
var GridStatusWidget = /** @class */ (function (_super) {
    __extends(GridStatusWidget, _super);
    function GridStatusWidget(baseUrl) {
        var _this = _super.call(this, { node: document.createElement("div") }) || this;
        _this.baseUrl = baseUrl;
        return _this;
    }
    GridStatusWidget.prototype.onAfterAttach = function (msg) {
        ReactDOM.render(React.createElement(grid_status_component_1.GridStatus, { updateInterval: 20000, baseUrl: this.baseUrl }), this.node);
        return Promise.resolve();
    };
    GridStatusWidget.prototype.onBeforeDetach = function (msg) {
    };
    GridStatusWidget.prototype.onAfterDetach = function (msg) {
    };
    return GridStatusWidget;
}(widgets_1.Widget));
exports.GridStatusWidget = GridStatusWidget;
//# sourceMappingURL=grid-status-widget.js.map