"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var $ = require("jquery");
var GridEngineService = /** @class */ (function () {
    function GridEngineService(baseUrl) {
        this.baseUrl = baseUrl;
    }
    GridEngineService.prototype.getStatus = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            $.get(_this.baseUrl + "grid").done(function (result) {
                resolve(result);
            })
                .fail(function (e) {
                reject(e);
            });
        });
    };
    GridEngineService.prototype.getStatusTest = function () {
        var getRand = function () { return (Math.floor(Math.random() * 99) + 1).toString(); };
        return new Promise(function (resolve) {
            resolve({
                gridStats: [
                    { name: "bobby", queued: getRand(), running: getRand(), halted: getRand() },
                    { name: "suzie", queued: getRand(), running: getRand(), halted: getRand() },
                    { name: "bobby", queued: getRand(), running: getRand(), halted: getRand() }
                ],
                total: getRand()
            });
        });
    };
    return GridEngineService;
}());
exports.GridEngineService = GridEngineService;
//# sourceMappingURL=grid-engine.service.js.map