/// <reference types="react" />
import * as React from "react";
import { GridEngineService } from './grid-engine.service';
export declare class GridStatusProps {
    updateInterval: number;
    baseUrl: string;
}
export declare class IGridStatusDetail {
    name: string;
    queued: string;
    running: string;
    halted: string;
}
export declare class GridStatusState {
    gridStats: Array<IGridStatusDetail>;
    total: number;
}
export declare class GridStatus extends React.Component<GridStatusProps, GridStatusState> {
    timer: any;
    gridEngineService: GridEngineService;
    constructor(props: any);
    updateStatus(): Promise<void>;
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
}
